/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("com.ibm.rational.report.web.core.app.internal.common.TeamAreaCombobox");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.requireLocalization("com.ibm.rational.report.web.core.app.serviceability", "Messages");

var ServiceabilityMessages = dojo.i18n.getLocalization("com.ibm.rational.report.web.core.app.serviceability", "Messages");

dojo.declare(
	"com.ibm.rational.report.web.core.app.internal.common.TeamAreaCombobox",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.rational.report.web.core", "app/internal/common/templates/TeamAreaCombobox.html"),
	
	constructor: function(processAreas) {
		for (var i = 0; i < processAreas.length; i++) {
			var processArea = processAreas[i];
			this._parseTeamAreas(processArea.children);
		}
	},
	
	postCreate: function() {		
	},	
	
	_parseTeamAreas: function(teamAreas) {
		if (teamAreas == null || teamAreas.length == 0) {
			return;
		}
		for (var i = 0; i < teamAreas.length; i++) {
			var teamArea = teamAreas[i];
			var option = new Option(teamArea.name, teamArea.itemId, false, false);	
			this.teamAreaCombo.options[this.teamAreaCombo.options.length] = option;				
			this._parseTeamAreas(teamArea.children);
		}
		
		if (this.teamAreaCombo.options.length > 0) {
			this.teamAreaCombo.options[0].selected = true;
		}
	},
	
	_getTeamAreasForUserError: function(error) {
		this._msgFormatter.displayErrorMessage(ServiceabilityMessages.FAILED_TO_RETRIEVE_TEAM_AREAS, error);
	},
	
	getSize: function() {
		return this.teamAreaCombo.options.length;
	},	
	
	getOptions: function() {
		return this.teamAreaCombo.options;
	},
	
	getOption: function(index) {
		if (index < this.teamAreaCombo.options.length) {
			return this.teamAreaCombo.options[index];
		}
		return null;
	},
	
	getOptionValue: function(index) {
		if (index < this.teamAreaCombo.options.length) {		
			return this.teamAreaCombo.options[index].value;
		}
		return null;
	},
	
	getSelectedOption: function() {
		return this.teamAreaCombo.options[this.teamAreaCombo.selectedIndex];
	},
		
	getSelectedOptionValue: function() {
		return this.teamAreaCombo.options[this.teamAreaCombo.selectedIndex].value;
	},
	
	setValue: function(value) {
		this.teamAreaCombo.value = value;
	}
	
});

})();